import objectdraw.*;
import java.awt.*;

public class MoveTarget2 extends WindowController
{
	private Movable[] group;
	private Movable dragme;
	private Location pos;
	private Location lastPoint;
	private boolean inBox;
	private boolean dragged;
	private int numObs;

	public void begin()
	{
		numObs = 20;
		group = new Movable[numObs];
		for(int i=0;i<group.length;i++)
		{
			int rand = (int)(Math.random()*10);
			if(rand < 3)
			{
				group[i] = new Target(Math.random()*canvas.getWidth(),
					Math.random()*canvas.getHeight(),canvas);
			}
			else if(rand < 6)
			{
				group[i] = new TargetPlus(Math.random()*canvas.getWidth(),
					Math.random()*canvas.getHeight(),canvas);
			}
			else
			{
				group[i] = new Square(new Location(Math.random()*canvas.getWidth(),
					Math.random()*canvas.getHeight()),canvas);
			}
		}
	}

	public void onMousePress(Location point)
	{
		lastPoint=point;
		for(int i=0;i<group.length;i++)
		{
			if(group[i].contains(point))
			{
				dragme = group[i];
				dragged = true;
				i = group.length;
			}
			else
			{
				dragged = false;
			}
		}
	}

	public void onMouseDrag(Location point)
	{
		if(dragged)
		{
			dragme.move(point.getX()-lastPoint.getX(),
			point.getY() - lastPoint.getY());
			lastPoint = point;
		}
	}

}